﻿using System;
using Newtonsoft.Json;
using Newtonsoft.Json.Serialization;

namespace ClientServer.Helpers
{
    public static class Jc
    {
        private static JsonSerializerSettings s;

        static Jc()
        {
            s = new JsonSerializerSettings { ContractResolver = new CamelCasePropertyNamesContractResolver() };
        }

        /// <summary>
        /// TODO maybe make this implicite for all
        /// </summary>
        /// <param name="obj"></param>
        /// <returns></returns>
        public static string Serialize(object obj)
        {
            return JsonConvert.SerializeObject(obj, s);
        }
        
        public static string SerializePlain(object obj)
        {
            string json = JsonConvert.SerializeObject(obj, s);
            return json;
        }

        /// <summary>
        /// deserializes the given obj
        /// </summary>
        /// <typeparam name="T">the expected type</typeparam>
        /// <param name="json">the json string</param>
        /// <returns>the created object or null if any errors occurred</returns>
        public static T Deserialize<T>(string json) where T: class
        {
            T result = null;
            try
            {
                result = JsonConvert.DeserializeObject<T>(json);
            }
            catch (Exception ex)
            {
                Console.WriteLine("error deserializing obj: " + ex.Message);
                Console.WriteLine("json: " + json);
                return null;
            }
            

            return result;
        }

        /// <summary>
        /// deserializes the given obj
        /// </summary>
        /// <typeparam name="T">the expected type</typeparam>
        /// <param name="json">the json string</param>
        /// <param name="serializerSettings">the settings</param>
        /// <returns>the created object or null if any errors occurred</returns>
        public static T Deserialize<T>(string json, JsonSerializerSettings serializerSettings) where T : class
        {
            T result = null;
            try
            {
                result = JsonConvert.DeserializeObject<T>(json, serializerSettings);
            }
            catch (Exception ex)
            {
                Console.WriteLine("error deserializing obj: " + ex.Message);
                Console.WriteLine("json: " + json);
                return null;
            }


            return result;
        }

    }
}
